=== test-suite/coq-makefile/compat-subdirs/subdir/Makefile ===
all:
	test -f ../theories/test.vo
	touch done
