=== debian/changelog ===
coq (8.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Updated patches:
     - remove-heavy-tests: also remove success/Nia.v
     - avoid-usr-bin-env.patch: also patch dev/tools/update-compat.py.
       Thanks to the Gianfranco Costamagna for the hint (closes: #952454)
  * Refreshed patches:
    - remove-tests-that-need-coqlib
    - python-scripts-libraries
    - skip-dot-pc
    - verbose-build
    - remove-bytecode-failing-tests
  * Removed patches:
    - ssrmatching-license: fixed by upstream
    - use-changelog-date: fixed by upstream
  * New patch:
    - restore_g_ssrmatching.mli
    - votour-linking: patch by Hugo Herbelin (thanks!) fixes linking of
      votour on bytecode architectures
  * invoke "make test" with PRINT_LOGS=1 as suggested by SkySkimmer (thanks)
  * disable building of the VM on s390x, as suggested by ejgallego (thanks)
    This should fix a test failure on s390x
    (https://github.com/coq/coq/issues/11395)
  * Dispatch into different binary packages:
    - simplify find invocation in debian/rules
    - add *.vos files, new *.cmo, *.cmxs files
    - add votour and doc_grammar binaries
  * Add an as-installed test for the compiler and the toplevel
  * Renamed debian/TODO.Debian to debian/TODO
  * Bump build-dependency on ocaml to >= 4.05, as indicated by INSTALL

 -- Ralf Treinen <treinen@debian.org>  Thu, 05 Mar 2020 21:37:30 +0100

coq (8.10.2-1) experimental; urgency=medium

  * New upstream release
    - update COQ_VERSION in debian/rules
  * Refreshed patches:
    - remove-heavy-tests.patch: drop removal of test-suite/bugs/closed/5127.v
      as this file is no longer distributed by upstream
    - avoid-usr-bin-env
    - python-scripts-libraries
    - verbose-build
    - remove-bytecode-failing-tests
    - remove-tests-that-need-coqlib.patch
  * Dropped patches:
    - remove-time-sensitive-tests, as none of these tests is distributed
      by upstream any more
    - 0013-Remove-test-failing-with-OCaml-4.08.0 as that test is no longer
      distributed by upstream
    - 0012-ocaml-4.08-does-not-allow-dynamic-loading-of-already
  * New patch use-changelog-date: use the date from the debian changelog
    entry, instead of the real time of compilation, in order to improve
    reproducibility. Based on a patch by Valentin Lorentz  (thanks!)
    (closes: #794130).
  * Reactivate building of coqide (closes: #920589, #946580)
    - put back the coqide paragraph in debian/control 
    - bump build-dependencies on lablgtk to version 3
    - coq suggests coqide as an alternative to proofgeneral
    - mention coqide in the long description of coq
    - put back debian/coqide.{1,desktop,dirs,install,links.in} from version
      8.6-5
    - update debian/*.install and debian/not-installed files
  * Build-Conflicts with libcoq-ocaml. This seems to be necessary to avoid
    that coq depends on two versions of libcoq-ocaml: the one being build,
    and the one currently installed.
  * Update libcoq-ocaml{-dev}.install.in
  * Move coqidetop from the coqide package to the coq package, following advice
    by upstream
  * Update docs
  * Generate html pages for the stdlib using HTMLSTYLE=simple, to avoid
    linking to external stylesheets
  * Build-depend on debhelper-compat, drop file debian/compat
  * Debhelper compatibility level 11
    - debian/rules: use "dh_missing --fail-missing" instead of
      "dh_install --fail-missing"
  * Standards-Version 4.4.1 (no change)
  * debian/copyright: updates of copyright holders in many files.
  * Add lintian-overrides for filenames containing wildcard characters
    in package coq-theories
  * debian/gbp.conf:
    - add doc/whodidwhat to the filter as this is part of the non-free
      reference manual
    - drop plugins/ssrmatching/g_ssrmatching.mli from the filter as
      upstream has fixed its license.

 -- Ralf Treinen <treinen@debian.org>  Wed, 01 Jan 2020 20:25:21 +0100
