=== debian/changelog ===
coq (8.12.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Ralf Treinen <treinen@debian.org>  Wed, 09 Sep 2020 21:16:07 +0200

coq (8.12.0-2) experimental; urgency=medium

  * Patch remove-heavy-tests: also remove test bugs/closed/bug_4544.v
    as it is a complexity test that tends to timeout on slow architectures.

 -- Ralf Treinen <treinen@debian.org>  Sun, 06 Sep 2020 09:59:04 +0200

coq (8.12.0-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches:
    - remove-tests-that-need-coqlib
    - remove-bytecode-failing-tests
    - avoid-usr-bin-env
    - python-scripts-libraries
    - skip-dot-pc
    - testsuite-bytecode
  * d/rules: update COQ_VERSION
  * Update versions of build-dependencies, according to INSTALL.md
  * d/*.install.in files:
    - install ssrsearch plugin in the libcoq-ocaml package
    - install ocamllibdep binary in the coq package
  * Debhelper compatibility level 13
    - drop override of dh_missing
  * Set Rules-Requires-Root=no

 -- Ralf Treinen <treinen@debian.org>  Fri, 21 Aug 2020 20:24:43 +0200

coq (8.11.1~pre1-1) experimental; urgency=medium

  * New upstream pre-release (tagged on github, but not yet officially
    announced).
  * Dropped patches:
    - votour-linking (fixed by upstream)
    - restore_g_ssrmatching.mli (fixed by upstream)
    - verbose-build (no longer useful as we are running the test-suite
      with PRINT_LOGS=1)
  * New patch testsuite-bytecode by Hugo Herbelin (thanks!): fixes failure
    of tests using locally generated makefiles on bytecode architectures.
  * Refreshed patches:
    - install-coqide-bytecode
    - remove-bytecode-failing-tests.patch
  * Extended patch remove-bytecode-failing-tests to also disable the test
    coq-makefile/findlib-package-unpacked
  * Dropped build-dependency hevea as we are not building the documentation
  * Replaced build-dependency on texlive-latex-extra by tex-common as we are
    not building the documentation, and just installing some tex files
  * Drop /usr/bin/doc_grammar from coq.install

 -- Ralf Treinen <treinen@debian.org>  Thu, 16 Apr 2020 18:34:27 +0200
