=== debian/control ===
--- 
+++ 
@@ -9,22 +9,22 @@
  Enrico Tassi <gareuselesinge@debian.org>
 Standards-Version: 4.5.0
 Build-Depends:
- debhelper-compat (= 11),
+ debhelper-compat (= 13),
  dh-exec,
  dh-ocaml (>= 0.9.5~),
  dh-python,
  ocaml-nox (>= 4.05),
- ocaml-findlib (>= 1.4.1),
+ ocaml-findlib (>= 1.8.0),
  camlp5 (>= 6.14),
  liblablgtk3-ocaml-dev,
- liblablgtksourceview3-ocaml-dev,
+ liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
  libnum-ocaml-dev,
  libounit-ocaml-dev,
  python3,
  rsync,
- texlive-latex-extra,
- hevea (>= 1.10-7)
+ tex-common
 Build-Conflicts: libcoq-ocaml
+Rules-Requires-Root: no
 Homepage: http://coq.inria.fr/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git
