=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.11.0
+COQ_VERSION := 8.12.0
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 ARCH := $(shell dpkg-architecture -q DEB_TARGET_ARCH)
@@ -105,10 +105,6 @@
 	find debian/tmp -name '.coq-native' -printf '%P\n' \
 	  >> debian/coq-theories.install
 
-.PHONY: override_dh_missing
-override_dh_missing:
-	dh_missing --fail-missing
-
 .PHONY: override_dh_install
 override_dh_install:
 	chmod +x debian/coq.install
